<CsoundSynthesizer>
<CsOptions>
;-iadc -odac 
;-M0 -+rtmidi=virtual -dm0     
;Before: sudo modprobe snd-virmidi 
;		a2jmidid
;-iadc:system:capture_  -odac:system:playback_ 
;-+rtaudio=jack 
;-+rtmidi=alsa -Mhw:2,0  -b 16 -B 1024
</CsOptions>
<CsInstruments>
sr = $SRATE
ksmps = $KRATE
nchnls = 2
0dbfs = 1
massign 0,0
zakinit 14, 1



opcode PitchShifter_akk, a, akki
ain, ksemitones, kquality, ihalfsine xin
;ksemitones number of semitones of trasposition
;kquality quality of the output - adds delay - from 0 to infinity
	imaxdlt init 2
	kdlt = .01 + .1 * kquality
	;ihalfsine	ftgen	0, 0, 2049, 9, 0.5, 1, 0	;HALF SINE  WINDOW FUNCTION USED FOR AMPLITUDE ENVELOPING

	koctfract	=	ksemitones/12			;TRANSPOSITION AS FRACTION OF AN OCTAVE
	kratio		=	octave(koctfract)		;RATIO TO PRODUCE PITCH SHIFT
	krate		=	(kratio-1)/kdlt 			;SUBTRACT 1/1 SPEED

	aphase1		phasor	-krate				;MOVING PHASE 1-0
	aphase2		phasor	-krate, .5			;MOVING PHASE 1-0 - PHASE OFFSET BY 180 DEGREES (.5 RADIANS)

	;What if ihalfine table dimension is increased?
	agate1		tablei	aphase1, ihalfsine, 1, 0, 1	;WINDOW FUNC =HALF SINE
	agate2		tablei	aphase2, ihalfsine, 1, 0, 1	;WINDOW FUNC =HALF SINE

	adlt		interp	kdlt				;CREATE A RATE (INTERPOLATED FROM K-RATE) VERSION OF kdlt
	aout		init	0				;INITIALISE OUTPUT AUDIO SIGNAL (NEEDED FOR FEEDBACK SIGNAL (METHOD 2))

	abuffer		delayr	imaxdlt				;DECLARE DELAY BUFFER
	adelsig1	deltap3	aphase1 * adlt			;VARIABLE TAP
	aGatedSig1	=	adelsig1 * agate1
			delayw	ain

	abuffer		delayr	imaxdlt				;DECLARE DELAY BUFFER
	adelsig2	deltap3	aphase2 * adlt			;VARIABLE TAP
	aGatedSig2	=	adelsig2 * agate2
			delayw	ain

	aout	dcblock2	(aGatedSig1 + aGatedSig2) * 0.5

	xout aout
endop



opcode AtanLimit, a, a
ain xin
aout = 2 * taninv(ain) / 3.1415927
xout aout
endop



;Control Channels
chn_k "inGain", 1;input gain (from GUI)
chn_k "inVUmeter", 2;input vumeter
chn_k "inThresh", 1;input threshold
chn_k "lockBpM", 1;output crossing threshold
chn_k "bpmOut", 2;from csound to host
chn_k "bpmIn", 1;from host to csound
chn_k "bpmError", 1;from host to csound

chn_k "modulatorSpeed", 1;input threshold
chn_k "shimmerDur", 1
chn_k "shimmerHP", 1

chn_k "stepOutN01", 2
chn_k "stepOutV01", 2
chn_k "stepSpeed01", 1
chn_k "maxStep01", 1
chn_k "durat01", 1
chn_k "basef01", 1
chn_k "ratiof01", 1

chn_k "stepOutN02", 2
chn_k "stepOutV02", 2
chn_k "stepSpeed02", 1
chn_k "maxStep02", 1
chn_k "durat02", 1
chn_k "basef02", 1
chn_k "ratiof02", 1

chn_k "stepOutN03", 2
chn_k "stepOutV03", 2
chn_k "stepSpeed03", 1
chn_k "maxStep03", 1
chn_k "durat03", 1
chn_k "basef03", 1
chn_k "ratiof03", 1

chn_k "stepOutN04", 2
chn_k "stepOutV04", 2
chn_k "stepSpeed04", 1
chn_k "maxStep04", 1
chn_k "durat04", 1
chn_k "basef04", 1
chn_k "ratiof04", 1

chn_k "ksteps", 1;in Channel
chn_k "ksteps_out", 2;out Channel
chn_k "ksteps_dur_out", 2;out Channel
chn_k "kduration", 1;in Channel
chn_k "kpointer", 2;out Channel
chn_k "krecordDly", 1
chn_k "kmaxDly", 1
chn_k "kquant", 1

chn_k "reverbFe", 1
chn_k "reverbFr", 1
chn_k "reverbDW", 1
chn_k "reverbLFr", 1

chn_k "outVUmeterL", 2
chn_k "outVUmeterR", 2

gktaptempo_t init 0;last tap temp time
gktaptempo_c init 0;counter of taps
gkbpm init 60
gindx init 0

;SEQUENCER TABLE
giseq01 ftgen 1, 0, 128, -2, 0

;Audio Table
giSine ftgen 100, 0, 16384, 10, 1

;Delay memory TABLE
gidel ftgen 10, 0, 32, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
											-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
gkdlymem_ind init 1
gkdelayActive init 0



;INSTRUMENTS------------------------------------------------------------------
alwayson "MainInstr"

instr MainInstr;input instrument

ainL, ainR ins;mono input
kvolIN chnget "inGain"
kvolINp port kvolIN, 0.05
ain = ainL * kvolINp

;ain noise kvolINp, 0.5


;threshold
ktrigVUmeter metro 3
aint buthp ain, 41
aint butlp aint, 1397
kinVU_rms max_k aint, ktrigVUmeter, 1
kinVU_rms_db = dbfsamp(kinVU_rms)
chnset kinVU_rms_db, "inVUmeter"

kThreshold chnget "inThresh"
;time trigger
ktrigger trigger kinVU_rms_db, kThreshold, 0;threshold in dB
;printk2 ktrigger


krecordDly chnget "krecordDly"
krecordDly init 0
if ktrigger == 1 then
	event "i", 5, 0, -1
	if krecordDly == 1 then;recording delay time
		event "i", 26, 1/kr, -1
	endif
endif
;check between in bpm (from host) and gkbpm calculated in csound
kbpmin chnget "bpmIn"
klockBpM chnget "lockBpM"
if klockBpM == 1 then
	gkbpm = kbpmin
endif	


;Modulators
krms rms ain
kmodulSpeed chnget "modulatorSpeed"
kmodO1 oscil 1, 18 * krms * kmodulSpeed, giSine
kmodO2 oscil 1, 17 * krms * kmodulSpeed, giSine, .5


;Shifters
ifftsize_ps = 256;1024
ioverlap_ps = ifftsize_ps / 4
iwinsize_ps = ifftsize_ps 
iwinshape_ps = 1
kkeepform_ps = 2
kgain_ps = 1
kcoefs_ps = 80
fftin pvsanal ain, ifftsize_ps, ioverlap_ps, iwinsize_ps, iwinshape_ps

fftPlus pvscale fftin, 2 + semitone(.05) * kmodO1, kkeepform_ps, kgain_ps, kcoefs_ps
fftPlusPlus pvscale fftin, 4  + semitone(.07) * kmodO2, kkeepform_ps, kgain_ps, kcoefs_ps
fftMinus pvscale fftin, 0.5, kkeepform_ps, kgain_ps, kcoefs_ps

afftPlus  pvsynth   fftPlus
afftPlusPlus  pvsynth   fftPlusPlus
afftMinus  pvsynth   fftMinus
afftPlusL, afftPlusR pan2 afftPlus, 0.5 + kmodO2 * .35
afftPlusPlusL, afftPlusPlusR pan2 afftPlusPlus, 0.5 + kmodO1 * .35


;Shimmer use already pitched to delay
kshimmerDur chnget "shimmerDur"
kshimmerHP chnget "shimmerHP"

ktimeShort portk 0.125 * 30 / gkbpm, 60 / gkbpm
adumpShort delayr 3 
atapShort deltap ktimeShort
delayw afftMinus - atapShort * (0.8 + 0.2 * kshimmerDur)
adumpShort2 delayr 3 
atapShort2 deltap ktimeShort
delayw atapShort

ktimeLong portk 0.33333 * 30 / gkbpm, 60 / gkbpm
adumpLong delayr 3
atapLong deltap ktimeLong
delayw afftPlus - atapLong * (0.8 + 0.2 * kshimmerDur)
adumpLong delayr 3
atapLong2 deltap ktimeLong
delayw atapLong

ashimmeringL buthp atapLong + atapShort2, kshimmerHP 
ashimmeringR buthp atapLong2 + atapShort, kshimmerHP 

;out
zawm ain, 0
;outs ain, ain
zawm (afftPlusL + afftPlusPlusL) * .3, 1
zawm (afftPlusR + afftPlusPlusR) * .3, 2
zawm afftMinus * .15, 3
zawm ashimmeringL * .5, 4
zawm ashimmeringR * .5, 5

event_i "i", 25, 0, -1
event_i "i", 31, 0, -1
event_i "i", 100, 0, -1
endin



instr 4;Clean Sequencer table
indx init 0
repeat:
	tableiw 0, indx, giseq01
loop_lt  indx, 1, 128, repeat
turnoff
endin



instr 5;time counter
;print p1
kTimer times
;reset after X seconds
if (kTimer - gktaptempo_t) > 3 then
	gktaptempo_c = 0
endif
;Trigger the calculator if not the first tap
kinterval = kTimer - gktaptempo_t
kmodu = (kinterval * 60 / gkbpm) % .25
;printk2 kmodu

klockBpM chnget "lockBpM"
kerror_ chnget "bpmError"
kerror = kerror_ * 0.01
if kmodu < kerror then
	event "i", 7, 0, -1, kinterval
elseif gktaptempo_c > 0 && kmodu > kerror && klockBpM < 1 then
	gkbpm = 60 / kinterval
endif
chnset gkbpm, "bpmOut"

gktaptempo_t = kTimer
gktaptempo_c = gktaptempo_c + 1
turnoff
endin



instr 7;percussive seqencer step manager
ibeat = p4 * 4 * 60 / i(gkbpm)
imodu = ibeat % .25
ibeat = round(ibeat - imodu) % 128

indx = gindx
repeat:
	istep tab_i (ibeat + indx) % 128, giseq01
	if istep == 0 then
		tablew 1, (ibeat + indx) % 128, giseq01
		gindx = indx
		igoto stop
	endif	
loop_lt  indx, 1, 128, repeat
stop:
turnoff
endin



instr 10;sequencers
;print p1
SchaFeed sprintf "stepSpeed%d", p4
SchaMaSt sprintf "maxStep%d", p4
SchaSON sprintf "stepOutN%d", p4
SchaSOV sprintf "stepOutV%d", p4
Schadur sprintf "durat%d", p4
Schabas sprintf "basef%d", p4
Scharat sprintf "ratiof%d", p4

kspeed chnget SchaFeed
kmaxstep chnget SchaMaSt
kstep init -1
ktrig metro kspeed * gkbpm / 60
if ktrig == 1 then
	kstep = (kstep + 1) % kmaxstep
	kval tab kstep, giseq01
endif

chnset kstep, SchaSON
chnset kval, SchaSOV

kdurat chnget Schadur
kbasef chnget Schabas
kratiof chnget Scharat

if ktrig == 1 && kval == 1 then
	event "i", 20 + 0.01 * p4 + 0.0001 * kstep, 0, kdurat, kbasef, kratiof
endif
endin



instr 15;metronome sequencer
kspeed chnget "metroSpeed"
kacc chnget "accent"
ktim chnget "timing"
krav chnget "randvol"
kexc chnget "exclude"
kdou chnget "double"


ktimrand = rnd(ktim)
kvolrand = rnd(krav)

kexcrand unirand 1
kdouble unirand 1

ktrig metro kspeed * gkbpm / 60

ktime = 60 / (kspeed * gkbpm)

kstep init -1
if ktrig == 1 then
	kstep = (kstep + 1) % kacc
	if kstep == 0 then
		kvol = 0.7 + 0.25 * kvolrand
	else
		kvol = 0.4 + 0.25 * kvolrand
	endif
	if kexcrand > kexc then;not excluded
		if kdouble > kdou then;single stroke
			event "i", 19 + 0.101 + 0.001 * kstep, ktime * 0.25 * ktimrand, ktime, kvol
		else;double stroke
			event "i", 19 + 0.101 + 0.001 * kstep, ktime * 0.25 * ktimrand, ktime / 2, kvol
			event "i", 19 + 0.201 + 0.001 * kstep, 0.5 * ktime + ktime * 0.25 * ktimrand, ktime / 2, kvol
		endif
	endif
endif
endin


instr 19;metronome audio
igain init .51
ipan init .5
kfreq_ chnget "kmetrofreq"
kfreq = kfreq_ + kfreq_ * p4 * 0.5
;kfreq = 210 + 130 * p4

aenv expseg 0.0001, 0.01, 1, p3 - 0.01, 0.0001
asig1 noise p4 * 0.7 * (aenv - 0.0001), 0
asig2 butlp asig1, kfreq * 2

asin1 oscil p4 * (aenv - 0.0001) * 0.23, kfreq * 0.5, giSine
asin2 oscil p4 * (aenv - 0.0001) * 0.2, kfreq + 13, giSine
asin3 oscil p4 * (aenv - 0.0001) * 0.15, kfreq * 2 + 7, giSine
asin4 oscil p4 * (aenv - 0.0001) * 0.15, kfreq * 3 - 9, giSine

asig	balance	asig2 * 0.7 + asin1 + asin2 + asin3 + asin4, asig1
a1, a2 pan2 asig * igain, ipan

zawm a1, 12
zawm a2, 13

endin




instr 20;audio for sequencers
ain0 zar 0
ain1 zar 4
ain2 zar 5
krms rms ain1 + ain2
iatt = 0.01

ipitchr random 0.8, 1.2
kfreq_ init p4
kfreq = kfreq_ * ipitchr 

iratior random 0.9, 1.1
kratio_ init p5
kratio = kratio_ * iratior

irandvol random 0.1, 0.35

katt linseg 0, iatt, 1, iatt, 0
att = (ain0 + ain1 + ain2) * katt
kpercenv linseg 0, iatt, 1, iatt * 3, 0.2, p3 - iatt * 4, 0
aperc1 oscil kpercenv * irandvol, kfreq + (ain0 + ain1 + ain2) * kfreq, giSine
aperc2 oscil kpercenv * irandvol, kratio * kfreq + (ain0 + ain2) * kfreq, giSine
aperc3 oscil kpercenv * irandvol, kfreq + 0.5 * kfreq * (aperc1 - aperc2), giSine

aperc = aperc1 + aperc2 + aperc3 + att

aout AtanLimit aperc

kpan = 0.5 + birnd(0.3)
aoutL, aoutR pan2 aout * 0.3, kpan
zawm aoutL, 6
zawm aoutR, 7
endin



instr 25;time pointer
kinnsss init 35
gkdelayActive active kinnsss
/*
gksmoother port 0.2 / (gkdelayActive + 1), 0.2
*/
;receive the value of beats
ksteps chnget "ksteps"
;initialize to value to avoid null in channels
ksteps init 8
;send to interface after receipt from interface
chnset ksteps, "ksteps_out"
;receive the duration of beats
kdur chnget "kduration"
;initialize to value to avoid null in channels
kdur init 0.5
;send out
chnset kdur, "ksteps_dur_out"
;reference bpm taken from variable gkbpm
;

ktrigverify changed ksteps, kdur
;to recheck delay table times
if ktrigverify == 1 then
	event "i", 27, 0, -1, gkdelayActive
endif

;correct time to avoid 0 and inf
ktime = (ksteps * kdur * 60 / gkbpm == 0 ? 0.001 : ksteps * kdur * 60 / gkbpm)
;create pointer
kpointer phasor 1 / ktime
;transmit to channel
chnset kpointer, "kpointer"
endin




instr 26;recording delay time
;deactivate older delays
kmaxDly chnget "kmaxDly";maximum numbers of delay lines

kpointer chnget "kpointer"
ksteps chnget "ksteps"
kdur chnget "kduration"

kcurrent = kpointer * ksteps * kdur * 60 / gkbpm

kquant chnget "kquant"
if kquant == 1 then
	kint = int(kcurrent / kdur)
	kfrac = frac(kcurrent / kdur)
	kcurrent = (kfrac >= 0.5 ? (kint + 1) * kdur : kint * kdur)
endif

;prints "kcurrent %f kint %f kfrac %f", kcurrent, kint, kfrac
if (kcurrent > 0) && (kcurrent <= (ksteps * kdur)) then
	tablew kcurrent, gkdlymem_ind, gidel;store value in the table
	event "i", 35 + 0.01 * gkdlymem_ind, 0, -1, gkdlymem_ind;activate delay
	gkdlymem_ind wrap gkdlymem_ind + 1, 1, 16
endif

event "i", 29, 0, -1, gkdelayActive, kmaxDly, gkdlymem_ind
turnoff
endin


instr 27;valid delay time
idelayActive = p4
indx init 0
imax = 16
isteps chnget "ksteps"
idur chnget "kduration"
clearnext:
	ival tab_i indx, gidel
	if ival > (isteps * idur) then
		tableiw -1, indx, gidel
		event_i "i", -35 - 0.01 * indx, 0, -1
	endif
loop_lt  indx, 1, imax, clearnext
turnoff
endin


instr 28;clear memory
indx init 0
imax = 16
clearnext:
tableiw -1, indx, gidel
event_i "i", -35 - 0.01 * indx, 0, -1
loop_lt  indx, 1, imax, clearnext
turnoff
endin


instr 29;killllll
idelayActive = p4
imaxDly = p5
iindx = p6
until idelayActive < imaxDly do
	ival tab_i iindx, gidel
	if ival > 0 then
		event_i "i", -35 - 0.01 * iindx, 0, -1
		tableiw -1, iindx, gidel
		idelayActive = idelayActive - 1
	endif
	iindx wrap iindx + 1, 1, 16
od
turnoff
endin




instr 31;premix for delay
aD zar 0
;outs aD, aD
aPL zar 1
aPR zar 2
aM zar 3
aSHL zar 4
aSHR zar 5

kdoutc chnget "aDout"
kdout port kdoutc, 0.05
kPitc chnget "aPIout"
kPit port kPitc, 0.05
kShimc chnget "aSout"
kShim port kShimc, 0.05


ainL = (aD  * kdout +
				aPL * kPit +
				aM * kPit +
				aSHL * kShim * .5) 
				
ainR = (aD  * kdout +
				aPR * kPit +
				aM * kPit +
				aSHR * kShim * .5) 
				
zawm ainL, 10
zawm ainR, 11

;outs ainL, ainR
endin


instr 35;delay (was instr 30)
itime tab_i p4, gidel
ktimed portk itime * 60 / gkbpm, 60 / gkbpm


;INPUT ZAC
ainL zar 10
ainR zar 11


;------- complex envelope block ------
xtratim 0.3 ;extra-time, i.e. release dur
krel init 0
krel release ;outputs release-stage flag (0 or 1 values)
if (krel == 1) kgoto rel ;if in release-stage goto release section
;
;************ attack and sustain section ***********
kmp1 line 0, .07, 1
kmp = kmp1
kgoto done
;
;--------- release section --------
rel:
kmp2 line 1, 0.3, 0
kmp = kmp1*kmp2
done:
;------


;printk2 ksmoother

adumpL delayr 100
	atapL deltap ktimed
delayw ainL * 0.05
	
adumpR delayr 100
	atapR deltap ktimed
delayw ainR * 0.05



zawm atapL * kmp, 8
zawm atapR * kmp, 9
endin




instr 100;master and VU
ametrL zar 12
ametrR zar 13
ainL zar 10
ainR zar 11
aPercL zar 6
aPercR zar 7
aDLYL zar 8
aDLYR zar 9

kMetrc chnget "aMEout"
kMetr port kMetrc, 0.05
kPercc chnget "aPEout"
kPerc port kPercc, 0.05
kDlyc chnget "aDLYout"
kDly port kDlyc * 0.05, 0.05

aoutL = (ainL +
				ametrL * kMetr + 
				aPercL * kPerc +
				aDLYL * kDly)

aoutR = (ainR +
				ametrR * kMetr + 
				aPercR * kPerc + 
				aDLYR * kDly)

;reverb
kfblvlc chnget "reverbFe"
kfblvl port kfblvlc, 0.05
kfcoc chnget "reverbFr"
kfco port kfcoc, 0.05
krdwc chnget "reverbDW"
krdw port krdwc, 0.05
khpc chnget "reverbLFr"
khp port khpc, 0.05

denorm aoutL, aoutR
alhr, arhr reverbsc aoutL, aoutR, kfblvl, kfco
alhr buthp alhr, khp
arhr buthp arhr, khp

apoL AtanLimit aoutL * cos(krdw * $M_PI_2) + alhr * sin(krdw * $M_PI_2)
apoR AtanLimit aoutR * cos(krdw * $M_PI_2) + arhr * sin(krdw * $M_PI_2)

outs apoL, apoR
zacl 0, 13

ktrigVUmeter metro 3
koutVU_rmsL max_k apoL, ktrigVUmeter, 1
koutVU_rmsL_db = dbfsamp(koutVU_rmsL)
chnset koutVU_rmsL_db, "outVUmeterL"
koutVU_rmsR max_k apoR, ktrigVUmeter, 1
koutVU_rmsR_db = dbfsamp(koutVU_rmsR)
chnset koutVU_rmsR_db, "outVUmeterR"


endin


instr 101;record output
aL, aR monitor
idata date
Sfile sprintf "recordings/%i_Spengger_recording.wav", idata
fout Sfile, 14, aL, aR
endin



</CsInstruments>
<CsScore>
</CsScore>
</CsoundSynthesizer>

