import wx
import fsm


class OutPanel(wx.Panel):
	def __init__(self, *a, **k):
		self.cSound = k.pop('cSound', None)
		self.cSound_perf = k.pop('cSound_perf', None)
		super(OutPanel, self).__init__(*a, **k)#super the subclass
		#self.SetBackgroundColour((200, 200, 200))
		siz = wx.Size(70,-1)#size of floatspin
		
		mixSizer  = wx.GridBagSizer(vgap=5, hgap=10)
		
		mixT = wx.StaticText(self, -1, "Mixer", style= wx.ALIGN_LEFT)
		directT = wx.StaticText(self, -1, "Direct", style= wx.ALIGN_LEFT)
		self.direct = fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 2.0,
				value = 0.3,
				increment = 0.1,
				size = siz,
				cSound = self.cSound,
				channel = "aDout")
		self.cSound.SetChannel("aDout", 0.3)

		
		pitchT = wx.StaticText(self, -1, "Pitched", style= wx.ALIGN_LEFT)
		self.pitch = fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 2.0,
				value = 0.3,
				increment = 0.1,
				size = siz,
				cSound = self.cSound,
				channel = "aPIout")
		self.cSound.SetChannel("aPIout", 0.3)
		
		shimT = wx.StaticText(self, -1, "Shimmer", style= wx.ALIGN_LEFT)
		self.shim =fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 2.0,
				value = 0.3,
				increment = 0.1,
				size = siz,
				cSound = self.cSound,
				channel = "aSout")
		self.cSound.SetChannel("aSout", 0.3)

		metroT = wx.StaticText(self, -1, "Metro", style= wx.ALIGN_LEFT)
		self.metro =fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 2.0,
				value = 0.7,
				increment = 0.1,
				size = siz,
				cSound = self.cSound,
				channel = "aMEout")
		self.cSound.SetChannel("aMEout", 0.7)
		
		seqT = wx.StaticText(self, -1, "Seq", style= wx.ALIGN_LEFT)
		self.seq =fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 2.0,
				value = 0.7,
				increment = 0.1,
				size = siz,
				cSound = self.cSound,
				channel = "aPEout")
		self.cSound.SetChannel("aPEout", 0.7)
		
		dlyyT = wx.StaticText(self, -1, "DLY", style= wx.ALIGN_LEFT)
		self.dlyy =fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 2.0,
				value = 0.3,
				increment = 0.1,
				size = siz,
				cSound = self.cSound,
				channel = "aDLYout")
		self.cSound.SetChannel("aDLYout", 0.3)
		
		
		
		
		reverbT = wx.StaticText(self, -1, "Reverb", style= wx.ALIGN_LEFT)
		
		reverbFeT = wx.StaticText(self, -1, "Size", style= wx.ALIGN_LEFT)
		self.reverbFe = fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 1.0,
				value = 0.5,
				increment = 0.01,
				size = siz,
				cSound = self.cSound,
				channel = "reverbFe")
		self.cSound.SetChannel("reverbFe", 0.5)		
		
		reverbFrT = wx.StaticText(self, -1, "cutoff", style= wx.ALIGN_LEFT)
		self.reverbFr =fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 100.0,
				max_val = 20000.0,
				value = 19000.0,
				size = siz,
				cSound = self.cSound,
				channel = "reverbFr")
		self.cSound.SetChannel("reverbFr", 19000)		
		
		reverbLFrT = wx.StaticText(self, -1, "cutLow", style= wx.ALIGN_LEFT)
		self.reverbLFr = fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 30.0,
				max_val = 5000.0,
				value = 50.0,
				size = siz,
				cSound = self.cSound,
				channel = "reverbLFr")
		self.cSound.SetChannel("reverbLFr", 50)		
		
		reverbDWT = wx.StaticText(self, -1, "DryWet", style= wx.ALIGN_LEFT)
		self.reverbDW =fsm.FsmCs(parent=self, id=-1,
				digits=3,
				min_val = 0.0,
				max_val = 1.0,
				value = 0.5,
				increment = 0.05,
				size = siz,
				cSound = self.cSound,
				channel = "reverbDW")
		self.cSound.SetChannel("reverbDW", 0.5)		
		
		
		vuLT = wx.StaticText(self, -1, "dB_L", style= wx.ALIGN_CENTER | wx.TE_RICH)
		self.vumeter_outL = wx.TextCtrl(self, -1, size=(60,20))
		vuRT = wx.StaticText(self, -1, "dB_R", style= wx.ALIGN_CENTER | wx.TE_RICH)
		self.vumeter_outR = wx.TextCtrl(self, -1, size=(60,20))
		
		
		#Timer Update MUST BE STOPPED IN MAIN FRAME
		self.timerRefresh = wx.Timer(self, wx.ID_ANY)
		self.timerRefresh.Start(50)
		self.Bind(wx.EVT_TIMER, self.timerUpdate, self.timerRefresh)
		
		
		
		mixSizer.Add(mixT, pos=(0,1))
		mixSizer.Add(directT, pos=(1,0))
		mixSizer.Add(self.direct, pos=(1,1))
		mixSizer.Add(pitchT, pos=(2,0))
		mixSizer.Add(self.pitch, pos=(2,1))
		mixSizer.Add(shimT, pos=(3,0))
		mixSizer.Add(self.shim, pos=(3,1))
		mixSizer.Add(metroT, pos=(4,0))
		mixSizer.Add(self.metro, pos=(4,1))
		mixSizer.Add(seqT, pos=(5,0))
		mixSizer.Add(self.seq, pos=(5,1))
		mixSizer.Add(dlyyT, pos=(6,0))
		mixSizer.Add(self.dlyy, pos=(6,1))
		
		mixSizer.Add(reverbT, pos=(7,1))
		mixSizer.Add(reverbFeT, pos=(8,0))
		mixSizer.Add(self.reverbFe, pos=(8,1))
		mixSizer.Add(reverbFrT, pos=(9,0))
		mixSizer.Add(self.reverbFr, pos=(9,1))
		mixSizer.Add(reverbLFrT, pos=(10,0))
		mixSizer.Add(self.reverbLFr, pos=(10,1))
		mixSizer.Add(reverbDWT, pos=(11,0))
		mixSizer.Add(self.reverbDW, pos=(11,1))
		
		mixSizer.Add(vuLT, pos=(12,0))
		mixSizer.Add(self.vumeter_outL, pos=(12,1))
		mixSizer.Add(vuRT, pos=(13,0))
		mixSizer.Add(self.vumeter_outR, pos=(13,1))
		
		
		self.vboxsizer = wx.BoxSizer(wx.VERTICAL)
		self.vboxsizer.Add(mixSizer, 0,flag=wx.EXPAND)
		#self.vboxsizer.AddSpacer(10,flag=wx.EXPAND)
		#self.vboxsizer.Add(self.recB, 0,flag=wx.EXPAND)
		
		#self.SetSizer(self.vboxsizer)
		#self.vboxsizer.Fit(self)
		#to add border to the panel
		sizx = wx.BoxSizer(wx.HORIZONTAL)
		sizy = wx.BoxSizer(wx.VERTICAL)
		sizx.AddSpacer(5,wx.EXPAND)
		sizx.Add(self.vboxsizer, 0,wx.EXPAND)
		sizx.AddSpacer(5,wx.EXPAND)
		sizy.AddSpacer(5,wx.EXPAND)
		sizy.Add(sizx, 0,wx.EXPAND)
		sizy.AddSpacer(5,wx.EXPAND)
		self.SetSizer(sizy)
		sizy.Fit(self)
		


		
	def timerUpdate(self, evt):
		"""update the vumeters"""
		self.dbL = self.cSound.GetChannel("outVUmeterL")
		self.dbR = self.cSound.GetChannel("outVUmeterR")
		if self.dbL < -1.0:
			self.vumeter_outL.SetForegroundColour((100,250, 100))
		elif -1.0<= self.dbL < 0.0:
			self.vumeter_outL.SetForegroundColour((250, 200, 0))
		else:
			self.vumeter_outL.SetForegroundColour((250, 10, 10))
		self.vumeter_outL.SetValue(str(self.dbL))
		if self.dbR < -1.0:
			self.vumeter_outR.SetForegroundColour((100,250, 100))
		elif -1.0<= self.dbR < 0.0:
			self.vumeter_outR.SetForegroundColour((250, 200, 0))
		else:
			self.vumeter_outR.SetForegroundColour((250, 10, 10))
		self.vumeter_outR.SetValue(str(self.dbR))

